#include <gtk/gtk.h>

#include "config.h"

#include "boilerplate-application.h"
#include "boilerplate-window.h"
#include "boilerplate-preferences.h"

typedef struct
{
    GSettings *settings;
} BoilerplatePreferencesPrivate;

G_DEFINE_TYPE_WITH_PRIVATE(BoilerplatePreferences, boilerplate_preferences, GTK_TYPE_WINDOW)

static void
_on_search (GtkEntry          *entry,
            BoilerplateWindow *window)
{
  /*
  ExampleAppWindowPrivate *priv;
  const gchar *text;
  GtkWidget *tab;
  GtkWidget *view;
  GtkTextBuffer *buffer;
  GtkTextIter start, match_start, match_end;

  text = gtk_entry_get_text (entry);

  if (text[0] == '\0')
    return;

  priv = example_app_window_get_instance_private (win);

  tab = gtk_stack_get_visible_child (GTK_STACK (priv->stack));
  view = gtk_bin_get_child (GTK_BIN (tab));
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));

  gtk_text_buffer_get_start_iter (buffer, &start);
  if (gtk_text_iter_forward_search (&start, text, GTK_TEXT_SEARCH_CASE_INSENSITIVE,
                                    &match_start, &match_end, NULL))
    {
      gtk_text_buffer_select_range (buffer, &match_start, &match_end);
      gtk_text_view_scroll_to_iter (GTK_TEXT_VIEW (view), &match_start,
                                    0.0, FALSE, 0.0, 0.0);
    }
  */
}

static void
_update_preference_example_combo () {

}

static void
_update_preference_csd () {

}

static void
_update_preference_dark () {

}

static void
boilerplate_preferences_dispose (GObject *object)
{
    BoilerplatePreferencesPrivate *priv;

    priv = boilerplate_preferences_get_instance_private (BOILERPLATE_PREFERENCES (object));
    g_clear_object (&priv->settings);

    G_OBJECT_CLASS (boilerplate_preferences_parent_class)->dispose (object);
}

//TODO: ~Fix preference~
//          Connect signals
//          General clean-up
//          Search feature
//          Pref description
static void
boilerplate_preferences_init (BoilerplatePreferences *preferences)
{
    BoilerplatePreferencesPrivate *priv;

    priv = boilerplate_preferences_get_instance_private (preferences);
    gtk_widget_init_template (GTK_WIDGET (preferences));
    //priv->settings = g_settings_new ("io.github.julianrichen.boilerplate");

    /*
    g_settings_bind (priv->settings, "font",
                     priv->font, "dark-theme",
                     G_SETTINGS_BIND_DEFAULT);

    g_settings_bind (priv->settings, "transition",
                     priv->transition, "active-id",
                     G_SETTINGS_BIND_DEFAULT);
    */
}

static void
boilerplate_preferences_class_init (BoilerplatePreferencesClass *class)
{
    G_OBJECT_CLASS (class)->dispose = boilerplate_preferences_dispose;

    gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (class),
                                               "/io/github/julianrichen/boilerplate/ui/preferences.ui");

    gtk_widget_class_bind_template_callback (GTK_WIDGET_CLASS (class), _on_search);

    /*
    gtk_widget_class_bind_template_child_private (GTK_WIDGET_CLASS (class), BoilerplatePreferences, font);
    gtk_widget_class_bind_template_child_private (GTK_WIDGET_CLASS (class), BoilerplatePreferences, transition);
    */
}

BoilerplatePreferences *
boilerplate_preferences_new (BoilerplateWindow *window)
{
    return g_object_new (BOILERPLATE_TYPE_PREFERENCES,
                         "transient-for", window,
                         NULL);
}
